

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 4
#property indicator_width2 4


double gda_76[];
double gda_80[];
extern int FasterEMA = 5;
extern int SlowerEMA = 13;
extern int RSIPeriod = 21;
extern bool Alerts = TRUE;
bool gi_100 = FALSE;
bool gi_104 = FALSE;
bool gi_108 = FALSE;
bool gi_112 = FALSE;
int gi_116 = 0;
int gi_120 = 0;
int gi_124 = 0;

int init() {
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, SYMBOL_ARROWUP);
   SetIndexBuffer(0, gda_76);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, SYMBOL_ARROWDOWN);
   SetIndexBuffer(1, gda_80);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_0;
   double ld_4;
   double ld_12;
   double ld_20;
   double ld_28;
   double ld_36;
   double ld_44;
   double ld_52;
   double ld_60;
   double ld_68;
   double ld_76;
   double ld_84;
   int li_92 = IndicatorCounted();
   if (li_92 < 0) return (-1);
   if (li_92 > 0) li_92--;
   int li_96 = Bars - li_92;
   for (int li_100 = 0; li_100 <= li_96; li_100++) {
      li_0 = li_100;
      ld_76 = 0;
      ld_84 = 0;
      for (li_0 = li_100; li_0 <= li_100 + 9; li_0++) ld_84 += MathAbs(High[li_0] - Low[li_0]);
      ld_76 = ld_84 / 10.0;
      ld_4 = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_CLOSE, li_100);
      ld_20 = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_CLOSE, li_100 + 1);
      ld_36 = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_CLOSE, li_100 - 1);
      ld_12 = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_CLOSE, li_100);
      ld_28 = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_CLOSE, li_100 + 1);
      ld_44 = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_CLOSE, li_100 - 1);
      ld_52 = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, li_100);
      ld_60 = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, li_100 + 1);
      ld_68 = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, li_100 - 1);
      if (ld_52 > 50.0 && ld_60 < 50.0 && ld_68 > 50.0) {
         gi_104 = TRUE;
         gi_112 = FALSE;
      }
      if (ld_52 < 50.0 && ld_60 > 50.0 && ld_68 < 50.0) {
         gi_104 = FALSE;
         gi_112 = TRUE;
      }
      if (ld_4 > ld_12 && ld_20 < ld_28 && ld_36 > ld_44) {
         gi_100 = TRUE;
         gi_108 = FALSE;
      }
      if (ld_4 < ld_12 && ld_20 > ld_28 && ld_36 < ld_44) {
         gi_100 = FALSE;
         gi_108 = TRUE;
      }
      if (gi_100 == TRUE && gi_104 == TRUE && gi_116 != 1) {
         gda_76[li_100] = Low[li_100] - 1.3 * ld_76;
         if (li_100 <= 2 && Alerts && !gi_120) {
            Alert(Symbol(), " ", Period(), " EMA-RSI Cross UP ");
            gi_120 = TRUE;
            gi_124 = FALSE;
         }
         gi_116 = 1;
      } else {
         if (gi_108 == TRUE && gi_112 == TRUE && gi_116 != 2) {
            gda_80[li_100] = High[li_100] + 1.3 * ld_76;
            if (li_100 <= 2 && Alerts && !gi_124) {
               Alert(Symbol(), " ", Period(), " EMA-RSI Cross DOWN ");
               gi_124 = TRUE;
               gi_120 = FALSE;
            }
            gi_116 = 2;
         }
      }
   }
   return (0);
}